typedef struct {
  int distance;
  int strength;
  int temp;
  boolean receiveComplete;
} TF;
TF Lidar = {0, 0, 0, false};
unsigned char buf1[] = {0x01, 0x03, 0x00, 0x00, 0x00, 0x02, 0xC4, 0x0B};
int Rdata;
int rx[11];
void resetRxData(int* rx) {
  for(int i = 0; i < 11; i++) {
    rx[i] = 0;
  }
}
void getLidarData(TF* lidar) 
{
  static char i = 0;
  char j = 0;
  Serial.write(buf1,8);
  delay(10);
  while (Serial.available()) 
  {
    Rdata = Serial.read();
    if(Rdata != ' ')
    {
      rx[i]=Rdata;
      if(rx[0] != 0x01){
        j = 1;
      }
      else if (i == 1 && rx[1] != 0x03) {
        j = 1;
      } 
      else if (i == 2 && rx[2] != 0x04) {
       j = 1;
      }
      else if (i == 9) 
      {
        lidar->distance = rx[4] + rx[3] * 256;
        lidar->strength = rx[6] + rx[5] * 256;
        lidar->receiveComplete = true;
        j = 1;
      } 
      i++;
      if(j==1)
      {
        Serial.flush();
        j=0;
        i=0;
      }
    }
  }
}/* First, the 9-bit data output by the radar is stored in the 'rx[]' array in order, and then the output distance, signal strength, and temperature are calculated*/ 


void setup() {
  Serial.begin(115200);
}

void loop() 
{
  getLidarData(&Lidar);
  if (Lidar.receiveComplete) 
  {
    Lidar.receiveComplete = false;
    Serial.println("Distance: " + String(Lidar.distance) + "cm\t" + "Strength: " + String(Lidar.strength) + "\t");
  }
}
