#include <HardwareSerial.h> // Reference the ESP32 built-in serial port library
HardwareSerial lidarSerial(2); // Use serial port 2
#define RXD2 16
#define TXD2 17
uint8_t buf1[10] = {0x01, 0x03, 0x00, 0x00, 0x00, 0x02, 0xC4, 0x0B}; // Hold an array of data
void setup() {
  Serial.begin(115200); // Initializes the serial port
  lidarSerial.begin(115200, SERIAL_8N1, RXD2, TXD2); // Initializes the Lidar serial port
}

void loop() {
  uint8_t buf[10] = {0}; // Hold an array of data
  lidarSerial.write(buf1, 8); // Write 8 bytes of data
  if (lidarSerial.available() > 0) {
    lidarSerial.readBytes(buf, 9); // Read 9 bytes of data
    if( buf[0] == 0x01 && buf[1] == 0x03 && buf[2] == 0x04)
    {
      uint16_t distance = buf[4] + buf[3] * 256;
      uint16_t strength = buf[6] + buf[5] * 256;
      Serial.print("Distance: ");
      Serial.print(distance);
      Serial.print(" cm, strength: ");
      Serial.println(strength);
    }
  }
  delay(10); // Delay 10ms
}