import serial
import time
ser = serial.Serial("/dev/ttyS0", 115200)
# we define a new function that will get the data from LiDAR and publish it
def read_data():
    time.sleep(1)  # Wait 
    while True:
        ser.write([0x01, 0x03, 0x00, 0x00, 0x00, 0x02, 0xC4, 0x0B])#Get distance and signal strength data
        
        time.sleep(0.05)  # Wait 
        counter = ser.in_waiting # count the number of bytes of the serial port
        if counter > 8:
            bytes_serial = ser.read(9)
            ser.reset_input_buffer()
    
            if bytes_serial[0] == 0x01 and bytes_serial[1] == 0x03 and bytes_serial[2] == 0x04: # python3
                distance = bytes_serial[4] + bytes_serial[3]*256
                strength = bytes_serial[6] + bytes_serial[5]*256
                print("TFmini-i python3 portion")
                print("Distance:"+ str(distance) + "cm")
                print("Strength:" + str(strength))
                ser.reset_input_buffer()
           
if __name__ == "__main__":
    try:
        if ser.isOpen() == False:
            ser.open()
        read_data()
    except KeyboardInterrupt:
        if ser != None:
            ser.close()
            print("program interrupted by the user")



